;
;                        USGARD APPEND LIBRARY
;                        written by Sam Davies
;				USGARD
;
;This library is useful for "anchoring" code, such as TSRs, in memory It
;adds, removes, and checks for code appended to the Usgard string.
;
;REQUIREMENTS:
;none.
;
UGAPPLIB = 12

;NAME:          APPEND
;INPUT:         HL -> location of code to be appended
;               BC = length of code to be appended
;OUTPUT:        HL -> location of appended code
;FUNCTION:      resizes the Usgard string and copies the specified block of
;               memory to the end of it.
APPEND = 0

;NAME:          UNAPPEND
;INPUT:         BC = length of code to be removed
;OUTPUT:        none
;FUNCTION:      removes last BC bytes from Usgard use in conjunction with
;               CHECK_APPEND.
UNAPPEND = 1

;NAME:          CHECK_APPEND
;INPUT:         HL -> location of code to check
;               BC = length of code to check
;OUTPUT:        If code is found: Zero flag reset, HL -> location in the
;                                 Usgard string.  If it is at the end,
;                                 Carry flag is set
;               If code is not found: Zero flag is set
;FUNCTION:      Searches through the Usgard string for the specified block of
;               memory.
CHECK_APPEND = 2
