#include "usgard.h"
#include "winlib.h"

.org 0
.db "Usgard Control Center",0
.db WINLIB,0

SetAddr = TEXT_MEM
LastByte = TEXT_MEM+2
FolderAddr = TEXT_MEM+4
FolderEnd = TEXT_MEM+6
Folder = TEXT_MEM+8
Program = TEXT_MEM+9
SetSize = TEXT_MEM+10

Begin:
R_OP:   ld      hl, OPFile
	call    VAR_GET
	jr      nc, SetTheAddr
;Make new string:
R_OP1:  ld      hl, OPFile
	ld      a, $0C
	ld      bc, 16
	call    VAR_NEW
	ret     c
	ld      (hl), $FF
	push    hl
	inc     hl
	ld      bc, 9
	call    OTH_CLEAR
	inc     hl
	ld      (hl), 240
	inc     hl
	ld      (hl), 0
	inc     hl
	ld      (hl), 240
	inc     hl
	ld      (hl), 0
	inc     hl
	ld      (hl), 240
	pop     hl
SetTheAddr:
	inc     hl
	ld      (SetAddr), hl
	dec     hl
	dec     hl
	ld      d, (hl)
	dec     hl
	ld      e, (hl)
	ld      (SetSize), de
	inc     hl
	inc     hl
	add     hl, de
	ld      (LastByte), hl
	ld      a, (hl)
Start:
	ld      de, (PROGRAM_ADDR)
R_C:    ld      ix, Contents1
        ld      bc, $0103
        ld      hl, $0E21
	ld      a, 11b
	LIB_CALL_(WINLIB,WIN_PSHOW)
	ld      ix, Contents2
R_DWC2: call    DrawWindow1
        ld      b, 4
	LIB_CALL_(WINLIB,WIN_CHOICE)
	ret     c
	and     a
	jr      z, ChangeBkPic
	dec     a
R_TF:   jp      z, ToolsFolder
	dec     a
R_GF:   jp      z, GamesFolder
	dec     a
R_SF:   jp      z, OtherFolder
        dec     a
R_CS:   jp      z, ChangeShell
	jr      Start

ChangeBkPic:
	ld      hl, $0000       ;search only B/W pics(enhanced explorer ver.)
	ld      de, $7D7D
R_CE0:  call    Explorer
        jr      nc, Start
	ld      de, (SetAddr)
	ld      bc, 9
	ldir
        jp     Start

ToolsFolder:
        ld      d, 1
	jr      ChgFold
GamesFolder:
        ld      d, 2
	jr      ChgFold
OtherFolder:
	ld      d, 3
ChgFold:
	RCALL_(ChangeFolder)
R_Begn: jp      Begin

;INPUT: D = folder to go to(1=tools,2=games,3=other)
ChangeFolder:
	ld      hl, (SetAddr)
	ld      bc, 9           ;skip background picture
	add     hl, bc
	dec     d
	ld      a, d
	ld      (Folder), a
	jr      z, NoSearch
	ld      bc, (SetSize)
        ld      a, 240
SearchFolder:
	cpir
	dec     d
	jr      nz, SearchFolder
NoSearch:
	ld      b, (hl)         ;number of entries
	ld      (FolderAddr), hl
	inc     hl
	ld      c, b
	ld      a, b
	and     a
	jr      z, SetFolderEnd
	ld      de, GRAPH_MEM
CopyLoop:
	ld      a, (hl)
	and     a
	jr      nz, CopyIt
	dec     b
	jr      z, CopyDone
	ld      a, LF
CopyIt:
	ld      (de), a
	inc     de
	inc     hl
	jr      CopyLoop
CopyDone:
	inc     hl
SetFolderEnd:
	inc     hl
	ld      (FolderEnd), hl
	ld      (de), a
;Okay, get choice:
	push    bc
	ld      ix, ChgFolder
R_DW3:  call    DrawWindow1
	pop     bc
WaitOption:
	call    GET_KEY
	cp      K_F1
	jr      z, AddEntry
	cp      K_F3
R_EF:   jp      z, EmptyFolder
	cp      K_EXIT
	ret     z
	dec     c
	inc     c
	jr      z, WaitOption
	cp      K_F2
	jr      nz, WaitOption

DelEntry:
	ld      ix, GRAPH_MEM
	ld      a, %10
	push    bc
	ld      bc, $0111
	ld      hl, $0E21
	LIB_CALL_(WINLIB,WIN_PSHOW)
	pop     bc
	ld      b, c
	dec     b
	LIB_CALL_(WINLIB,WIN_CHOICE)
	ret     c
	ld      (Program), a
	ld      hl, (FolderAddr)           ;search for the var specified
	dec     (hl)
	inc     hl
	ld      a, (Program)
	and     a
	jr      z, NoNeedToSearch
	ld      d, a
	ld      bc, 1000
	xor     a
SearchProg:
	cpir
	dec     d
	jr      nz, SearchProg
NoNeedToSearch:
	ld      d, h
	ld      e, l
	xor     a
	ld      c, 100
	cpir
	ld      a, 100
	sub     c
	ld      (FolderEnd), hl
	ld      b, h
	ld      c, l
	ld      hl, (LastByte)
	or      a
	sbc     hl, bc
	jr      z, DontMove
	ld      b, h
	ld      c, l
	ld      hl, (FolderEnd)
	ldir
DontMove:
	ld      hl, (SetSize)
	ld      b, 0
	ld      c, a
	or      a
	sbc     hl, bc
	ld      b, h
	ld      c, l
R_OP2:  ld      hl, OPFile
	call    VAR_RESIZE
	ret
AddEntry:
	ld      hl, $0000
	ld      de, $FAFE
R_CE2:  call    Explorer

	ret     nc
	call    ASCIIZ_LEN
	inc     bc
	ld      hl, (SetSize)
	add     hl, bc
	ld      b, h
	ld      c, l
R_OP0:  ld      hl, OPFile
	call    VAR_RESIZE      ;resize!
	ret     c
;Get new end of file:
R_OP6:  ld      hl, OPFile
	call    VAR_GET
	dec     hl
	dec     hl
	ld      e, (hl)
	inc     hl
	ld      d, (hl)
	add     hl, de
	ex      de, hl
	ld      hl, (LastByte)
	dec     hl
	push    hl
	ld      bc, (FolderEnd)
	or      a
	sbc     hl, bc
	ld      b, h
	ld      c, l
	pop     hl
	inc     bc
	inc     bc
	lddr
	ld      de, (FolderEnd)
	dec     de
	ld      hl, OP2
	call    ASCIIZ_LEN
	inc     bc
	ldir
	ld      hl, (FolderAddr)
	inc     (hl)
	ret

EmptyFolder:
	ld      de, (FolderAddr)
	inc     de
	inc     de
	ld      hl, (FolderEnd)
	ld      b, h
	ld      c, l
	or      a
	sbc     hl, de
	push    hl
	ld      hl, (LastByte)
	or      a
	sbc     hl, bc
	jr      z, NoNeedToMove
	ld      b, h
	ld      c, l
	ld      hl, (FolderEnd)
	ldir
NoNeedToMove:
	ld      hl, (FolderAddr)
	ld      (hl), 0
	inc     hl
	ld      (hl), 240
	ld      hl, (SetSize)
	pop     bc
	or      a
	sbc     hl, bc
	ld      b, h
	ld      c, l
R_OP3:  ld      hl, OPFile
	call    VAR_RESIZE
	ret

ChangeShell:
        ld      hl, $0000
        ld      de, $FAFE
R_CE1:  call    Explorer
        jr      nc, R_ST
        ld      de, USGSHELL
        ld      bc, 9
        ldir
R_ST:   jp      Start

Explorer:
	push    hl
	push    de
	ld      hl, TEXT_MEM
R_Temp: ld      de, SaveTemp
	ld      bc, 12
	ldir
	pop     de
	pop     hl

	ld      bc, &ETitle
	LIB_CALL_(2,0)

	push    hl
	ld      de, TEXT_MEM
R_Tmp2: ld      hl, SaveTemp
	ld      bc, 12
	ldir
	pop     hl
	ret

DrawWindow1:
        ld     bc, $0111
        ld     de, $0E21
	ld     a, 10b
	push   de
	ld     de, (PROGRAM_ADDR)
	add    hl, de
	add    ix, de
	ex     de, hl
	pop    hl
	LIB_CALL_(WINLIB,WIN_PSHOW)
	ret

Contents1:
 .db "CHOOSE AN OPTION:",0

Contents2:
 .db "CHANGE BACKGROUND PIC",LF
 .db "MODIFY TOOLS FOLDER",LF
 .db "MODIFY GAMES FOLDER",LF
 .db "MODIFY STARTUP FOLDER",LF
 .db "CHANGE SHELL",0

ChgFolder:
 .db TAB,"[F1] Add entry",LF
 .db TAB,"[F2] Del entry",LF
 .db TAB,"[F3] Empty folder",0

OPFile:
 .db "usgdset",0

SaveTemp:
 .dw 0,0,0,0,0,0

ETitle:
 .db "Choose file to add",0

.end
