;A CShell like shell.
#include        "usgard.h"

.org    0
.db     "Usgard Simple Shell",0
.db	0

MAXP = 9
MAX_PROGS = TEXT_MEM

	ld      c, 0
StartNew:
	ld      hl, VAT_START-10
	ld      (&VAT_Find+1), hl

Start:
;Draw the screen
	push    bc
	call    CLEARLCD

	ld      hl, VIDEO_MEM
	ld      de, VIDEO_MEM+1
	ld      (hl), 255
	ld      bc, 111
	ldir

	set     3, (iy+05)
	ld      hl, $0001
	ld      (CURSOR_X), hl
	ld      hl, (PROGRAM_ADDR)
	call    D_ZM_STR

	ld      hl, VIDEO_MEM+(8*16)+4
	ld      de, 16
	ld      b, 55
VertLine:
	ld      (hl), $08
	add     hl, de
	djnz    VertLine

;Find available programs:
Start_VAT:
	ld      hl, $0801
	ld      (CURSOR_X), hl

VAT_Find:
	ld      hl, VAT_START-10
	ld      ix, TEXT_MEM2
	xor	a
	ld	(MAX_PROGS), a
VAT_Loop:
	ld	a, $0C
	call	SEARCH_VAT
	jr	c, VAT_Done
	ld	a, (de)
	and	a
	jr	nz, VAT_Loop
	inc	de
	ld	a, (de)
	cp	$FA
	jr	c, VAT_Loop
	push	hl
	inc	de
	inc	de
	ld	hl, (PROGRAM_ADDR)
	or	a
	sbc	hl, de			;'CP_HL_DE'
	pop	hl
	jr	z, VAT_Loop		;this is the actual shell, skip it
;Write out name:
	push    hl
	ld	hl, VATName
	call    D_ZM_STR
	ex      de, hl
	ld      a, 40
	ld      (CURSOR_X), a
	call    D_ZM_STR
	ld      a, (CURSOR_Y)
	add     a, 6
	ld      (CURSOR_Y), a
	ld      a, 1
	ld      (CURSOR_X), a
	pop     hl

;Copy name:
	push	ix
	pop	de
	push	hl
	ld	hl, VATName
	ld	bc, 9
	ldir

	ld	hl, MAX_PROGS
	inc	(hl)
	ld	a, (hl)
	pop	hl
	push	de
	pop	ix

	cp	MAXP
	jr      c, VAT_Loop
VAT_Done:
	pop     bc

	ld      a, (MAX_PROGS)
	and	a
	ret	z

	cp      MAXP
	jr      z, SetVAT
	ld      hl, VAT_START-10
SetVAT:
	ld      (&VATPos), hl

	dec     a
	ld      (MAX_PROGS), a
	cp	c
	jr	nc, ProgramLoop
	ld	c, a

ProgramLoop:
	ld      (iy+8), $8C
	call    &Invert
KeyLoop:
	call    GET_KEY
	and     a
	jr      z, KeyLoop
	call    &Invert
	call    $115
	ld      (iy+8), $84
	cp      K_EXIT
	ret     z
	cp      K_UP
	jr      z, Up
	cp      K_DOWN
	jr      z, Down
	cp      K_MORE
	jr      z, NextPage
	cp      K_ENTER
	jr      z, Exec
	cp      K_SECOND
	jr      z, Exec
	ld      hl, CONTRAST
	cp      K_PLUS
	jr      z, ContUp
	cp      K_MINUS
	jr	z, ContDown
	cp	K_ALPHA
	call	z, OTH_SHUTDOWN
	jr      ProgramLoop

ContDown:
	ld      a, (hl)
	sub     1
	jr      c, ProgramLoop
	ld      (hl), a
	out     (2), a
	jr      ProgramLoop
ContUp:
	ld      a, (hl)
	cp      31
	jr      z, ProgramLoop
	inc     (hl)
	ld      a, (hl)
	out     (2), a
	jr      ProgramLoop

Up:
	ld      a, c
	and     a
	jr      z, NextPage0
	dec     c
	jr      ProgramLoop
Down:
	ld      a, c
	ld      hl, MAX_PROGS
	cp      (hl)
	jr      z, NextPage
	inc     c
	jr      ProgramLoop
NextPage0:
	ld	c, 9
	jr	NextPage1
NextPage:
	ld      c, 0
NextPage1:
	ld      hl, (&VATPos)
	ld      (&VAT_Find+1), hl
JumpStart:
	jp      &Start

Exec:
	push    bc
	ld	h, 9
	ld	l, c
	call	MUL_HL
	ld      de, TEXT_MEM2
	add	hl, de
	call    VAR_EXEC
	im      2
	pop     bc
	ld	hl, USG_BITS
	bit	1, (hl)
	call	nz, OTH_EXIT
	jr      JumpStart

Invert:
	push    af
	ld      h, 16*6
	ld      l, c
	call    MUL_HL
	ld      de, VIDEO_MEM+128
	add     hl, de
	ld      b, 112
InvLoop:
	ld      a, (hl)
	cpl
	ld      (hl), a
	inc     hl
	djnz    InvLoop
	pop     af
	ret

VATPos:
	.dw 0

.end
