;
;	       		ZShell Compressed Pictures
;	by Stephan Jantzen - optimized by Andreas Ess for Usgard
;
;This is a small, easy-to-use library for ZCP pictures
;
;REQUIREMENTS:
;None!
;
#include "usgard.h"

.db $80

.dw DeZCP

;Parameters: HL = image
DeZCP:
 push   HL
 call	CLEARLCD
 pop    IX
 ld     HL, VIDEO_MEM
 ld     C, 128
;Now:
; A 	temporary storage
; B	loop counter
; C	'bit counter'
; DE	pointer to Data var
; HL	VIDEO_MEM
; IX	the compressed data
CLoop:
 inc    IX
 ld     A,(IX)
 and    A
 jr     Z,EndDecode
 ld	E, A
 bit    7,A
 jr     NZ,Copy
Stream:
 and    $3F
 ld     B, A
StreamLoop:
 bit	6, E
 jr	z, DrawNoP
 ld     A, (HL)
 or     C
 ld     (HL), A
DrawNoP:
 rrc    C
 jr     NC, GoOnZCP1
 inc    HL
GoOnZCP1:
 djnz   StreamLoop
 jr     CLoop
Copy:
 rl	E
 ld     B, 7
CopyLoop:
 rl	E
 jr	nc, DrawNoPoint
 ld     A, (HL)
 or     C
 ld     (HL), A
DrawNoPoint:
 rrc    C
 jr     nc, GoOnZCP
 inc    HL
GoOnZCP:
 djnz   CopyLoop
 jr     CLoop
EndDecode:
 ret

.end
